#include <string>
#include <iostream>

class Pieza 
{
private:	
	int color;
	int altura;
	int anchura;

protected:	
	std::string nombre;
	int x,y;

public:
	Pieza(int color, int altura, int anchura)
	{
		this->color   = color;
		this->altura  = altura;
		this->anchura = anchura;
	}

	void get_nombre()
	{
		std::cout << nombre << std::endl;
	}

	// Mueve pieza a nueva posicin
	virtual void mueve_escaque()=0;

	// Imprime los datos de la pieza
	virtual void imprime_datos() 
	{
		std::cout << "Color: "   << color   << std::endl; 
		std::cout << "Altura: "  << altura  << std::endl;
		std::cout << "Anchura: " << anchura << std::endl; 
	}
};


class Peon : public Pieza 
{
private:	
	bool amenaza_peon; // Si amenaza a otra pieza
public:	
	Peon(int color, int altura, int anchura):Pieza(color, altura, anchura) 
	{
		nombre = "Peon7";
		x = 7;
		y = 2;
		amenaza_peon = false;
	}

	void mueve_escaque() 
	{ // Movimiento del peon
		y++;
		amenaza_peon = true;
		
	}

	void imprime_datos() 
	{
		std::cout << "Se encuentra amenazando el peon?: " << (amenaza_peon ? "SI" : "NO") << std::endl;
		Pieza::imprime_datos();
	}
};


class Torre : public Pieza 
{
private:	
	bool amenaza_torre; // Si amenaza a otra pieza
public:	
	Torre(int color, int altura, int anchura):Pieza(color, altura, anchura) 
	{
		nombre = "Torre1";	
		x = 1;
		y = 1;
		amenaza_torre = false;
	}

	void mueve_escaque() 
	{ // Movimiento de la torre
		y+= 7;
		amenaza_torre = true;
	}

	void imprime_datos()
	{
		std::cout << "Se encuentra amenazando la torre?: " << (amenaza_torre ? "SI" : "NO") << std::endl;
		Pieza::imprime_datos();
	}
};

class Caballo : public Pieza
{
private:	
	bool amenaza_caballo; // Si amenaza a otra pieza
public:	
	Caballo(int color, int altura, int anchura):Pieza(color, altura, anchura) 
	{
		nombre = "Caballo1";	
		x = 2;
		y = 1;
		amenaza_caballo = false;
	}

	void mueve_escaque() 
	{ // Movimiento del caballo
		x++;
		y+= 2;
		amenaza_caballo = true;
	}

	void imprime_datos() 
	{
		std::cout << "Se encuentra amenazando el caballo?: " << (amenaza_caballo ? "SI" : "NO") << std::endl;
		Pieza::imprime_datos();
	}
};

int main()
{
	Peon peon(1, 10, 5);
	Torre torre(2, 20, 5);
	Caballo caballo(3, 10, 10);
	
	Pieza* pieza = &torre;
	
	pieza->mueve_escaque(); // Llamada a mueve_escaque de Torre
	pieza->imprime_datos(); // Llamada a imprime_datos de Torre y Pieza

	Torre* p_torre = dynamic_cast<Torre*>(pieza); // Conversin

	p_torre->mueve_escaque();
	p_torre->imprime_datos();
	
	std::cin.get();

	return 0;
}

