#ifndef comunicaciones_h
#define comunicaciones_h

#include <iostream>
#include <string>
#include <vector>

using namespace std;

namespace comunicaciones
{
	// Interfaz I_observer
	class I_observer
	{
	public:	
		virtual void notifica_mensaje(const string& mensaje) = 0;
	};

	// Interfaz I_comunicacion
	class I_comunicacion
	{
	public:	
		virtual void enviar_mensaje(const string& mensaje) = 0;
		virtual void recibe_mensaje(const string& mensaje) = 0;
	};

 	class Notificador
	{
	private:
		vector<I_observer*> lista_observers;
	public:
		void adjunta(I_observer* observer);
		void notifica(const string& mensaje);
	};
	
	// Implementa interfaz I_comunicacion
	class Fachada_comunicaciones : public I_comunicacion
	{
	private:
		Notificador notificador;
	public:
		void enviar_mensaje(const string& mensaje);
		void recibe_mensaje(const string& mensaje);
		Notificador& get_notificador();
	};

}

#endif