#ifndef gestion_juego_h
#define gestion_juego_h

#include <iostream>
#include "../comunicaciones/comunicaciones.h"
#include "../gui/gui.h"
#include "../ajedrez/ajedrez.h"


using namespace ajedrez;
using namespace comunicaciones;
using namespace GUI;
using namespace std;

namespace gestion_juego
{
	class Time
	{
	};
	
	// Implementa interfaces I_gui e I_observer
	class Control_juego : public GUI::I_gui, public comunicaciones::I_observer
	{
	private:
		Time tiempo_limite;
		Time tiempo_a;
		Time tiempo_b;
		int turno;
		int fil_orig;
		int col_orig;
		int fil_dest; 
		int col_dest;
		GUI::Gui& gui_ref;
		comunicaciones::I_comunicacion& com_ref;
		ajedrez::Jugador_humano& humano_ref;
		ajedrez::IA& ia_ref;
	public:
		Control_juego(GUI::Gui& gui, comunicaciones::I_comunicacion& com, ajedrez::Jugador_humano& humano, ajedrez::IA& ia);
		// Heredadas de I_gui
		void on_destino(int x_dest, int y_dest);
		void on_origen(int x_orig, int y_orig);
		void on_consejo();
		// Heredadas de I_observer
		void notifica_mensaje(const string& mensaje);
		// Propias
		void aconsejar();
		void inicia_partida();
		void termina_partida();
		void buscar_contrincante();
		void turno_ia();
	private:	
		void hacer_movimiento(int fil_orig, int col_orig, int fil_dest, int col_dest);
		bool detecta_amenaza(int fila, int columna);
		bool jugada_correcta(int fila, int columna, const string& pieza);
		bool mate(int fila, int columna);
		int  convierte_xy(int cord) ;
	};
}

#endif