#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#include <iostream>

#include "gestion_juego\gestion_juego.h"

using namespace std;
using namespace comunicaciones;
using namespace GUI;
using namespace gestion_juego;
using namespace ajedrez;

int main() 
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

	Tablero tablero;
	Gui gui(tablero);
	Fachada_comunicaciones com;
	
	Jugador_humano humano(com);
	IA ia(humano);
	Final final;
	Algoritmo_GPU algoritmo(humano, ia, final);
	ia.set_algoritmo(&algoritmo);
	
	Control_juego juego(gui,com,humano,ia);

	com.get_notificador().adjunta(&gui);
	com.get_notificador().adjunta(&juego);
	com.get_notificador().adjunta(&tablero);

	com.recibe_mensaje("Iniciar conexion");
	
	cout << "Turno del jugador humano" << endl;
	cout << "------------------------" << endl;

	juego.on_origen(400,200);
	juego.on_destino(400,700);
	juego.on_consejo();		
	
	cout << "Turno de la IA" << endl;
	cout << "--------------" << endl;
	
	juego.turno_ia();

	com.recibe_mensaje("Cerrar conexion");
	
	cin.get();



	return 0;
}