﻿#include "asignacion.h"

using namespace std;

Ingeniero::Ingeniero(int numero)
{
	this->numero = numero;
}

bool Ingeniero::set_asignacion(Asignacion* asignacion)
{
	// Evita repetidos
	if (asignaciones[asignacion->get_ID()] == NULL)
	{
		asignaciones[asignacion->get_ID()] = asignacion;
		cout << "es true" << asignacion->get_ID() << endl;
		return true;
	}
	cout << "REPETIDO" << std::endl;
	return false;
}

string Ingeniero::to_string()
{
	stringstream ss;
	ss << numero;
	return "Ingeniero " + ss.str();
}

string Ingeniero::get_ID()
{
	stringstream ss;
	ss << numero;
	return "ING" + ss.str();
}

void Ingeniero::imprime_proyectos()
{
	cout << to_string() << " con los proyectos " << endl;

	map<string, Asignacion*>::iterator it = asignaciones.begin();
	for (it = asignaciones.begin(); it != asignaciones.end(); it++)
	{
		cout << (*it).second->get_proyecto()->to_string() << endl;
	}
}


void Asignacion::add_relacion(Ingeniero* ingeniero, Proyecto* proyecto, int presupuesto)
{
	// Genera clave
	id = ingeniero->get_ID() + proyecto->get_ID();
	this->ingeniero = ingeniero;
	this->proyecto = proyecto;
	this->presupuesto = presupuesto;
	if (ingeniero->set_asignacion(this))
	{
		proyecto->set_asignacion(this);
	}
}

string Asignacion::get_ID()
{
	return id;
}

Proyecto* Asignacion::get_proyecto()
{
	return proyecto;
}

Ingeniero* Asignacion::get_ingeniero()
{
	return ingeniero;
}


Proyecto::Proyecto(int numero)
{
	this->numero = numero;
}

void Proyecto::set_asignacion(Asignacion* asignacion)
{
	asignaciones[asignacion->get_ID()] = asignacion;
}

string Proyecto::to_string()
{
	stringstream ss;
	ss << numero; 
	return "Proyecto " + ss.str();
}

string Proyecto::get_ID()
{
	stringstream ss;
	ss << numero;
	return "PRY" + ss.str();
}

void Proyecto::imprime_ingenieros()
{
	cout << to_string() << " con los ingenieros " << endl;

	map<string, Asignacion*>::iterator it = asignaciones.begin();
	for (it = asignaciones.begin(); it != asignaciones.end(); it++)
	{
		cout << (*it).second->get_ingeniero()->to_string() << endl;
	}
}


int main()
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	
	Ingeniero* ingenieros[3];
	for (int i = 0; i < 3 ; i++)
	{
		ingenieros[i] = new Ingeniero(i);
	}

	Proyecto* proyectos[3];
	for (int i = 0; i < 3 ; i++)
	{
		proyectos[i] = new Proyecto(i);
	}

	Asignacion* asignaciones[3];
	for (int i = 0; i < 3 ; i++)
	{
		asignaciones[i] = new Asignacion();
	}

	asignaciones[0]->add_relacion(ingenieros[0], proyectos[0],1000);
	asignaciones[1]->add_relacion(ingenieros[0], proyectos[1],2000);
	asignaciones[2]->add_relacion(ingenieros[0], proyectos[2],3000);

	ingenieros[0]->imprime_proyectos();
	proyectos[1]->imprime_ingenieros();

	for (int i = 0; i < 3 ; i++)
	{
		delete ingenieros[i];
	}

	for (int i = 0; i < 3 ; i++)
	{
		delete proyectos[i];
	}

	for (int i = 0; i < 3 ; i++)
	{
		delete asignaciones[i];
	}
	
	cin.get();
	return 0;
}
