
package ejemplo3;

abstract class Pieza 
{
	private int color;
	private int altura;
	private int anchura;

	protected String nombre;
	
    protected int x,y;
        
    public Pieza(int color, int altura, int anchura) 
	{
		this.color   = color;
		this.altura  = altura;
		this.anchura = anchura;
	}

	public void getNombre() 
	{
		System.out.println(nombre);
	}

	// Mueve pieza a nueva posición
	public abstract void mueveEscaque();

	// Imprime los datos de la pieza
	public void imprimeDatos() 
	{
		System.out.println("Color: " + color); 
		System.out.println("Altura: " + altura);
		System.out.println("Anchura: " + anchura); 
	}
};



class Peon extends Pieza 
{
	private boolean amenazaPeon; // Si amenaza a otra pieza

	public Peon(int color, int altura, int anchura) 
	{
		super(color, altura, anchura);
                nombre = "Peon7";
		x = 7;
		y = 2;
		amenazaPeon = false;
	}

	public void mueveEscaque() 
	{ // Movimiento del peon
		y++;
		amenazaPeon = true;
		
	}

	public void imprimeDatos() 
	{
		System.out.println("¿Se encuentra amenazando el peon?: " + (amenazaPeon ? "SI" : "NO"));
		super.imprimeDatos();
	}
};


class Torre extends Pieza 
{
	private boolean amenazaTorre; // Si amenaza a otra pieza

	public Torre(int color, int altura, int anchura) 
	{
                super(color, altura, anchura);
		nombre = "Torre1";	
		x = 1;
		y = 1;
		amenazaTorre = false;
	}

	public void mueveEscaque() 
	{ // Movimiento de la torre
		y+= 7;
		amenazaTorre = true;
	}

	public void imprimeDatos() 
	{
		System.out.println("¿Se encuentra amenazando la torre?: " + (amenazaTorre ? "SI" : "NO"));
		super.imprimeDatos();
	}
};

class Caballo extends Pieza 
{
	boolean amenazaCaballo; // Si amenaza a otra pieza
	
	public Caballo(int color, int altura, int anchura) 
	{
                super(color, altura, anchura);
                nombre = "Caballo1";	
		x = 2;
		y = 1;
		amenazaCaballo = false;
	}

	public void mueveEscaque() 
	{ // Movimiento del caballo
		x++;
		y+= 2;
		amenazaCaballo = true;
	}

	public void imprimeDatos()
	{
		System.out.println("¿Se encuentra amenazando el caballo?: " + (amenazaCaballo ? "SI" : "NO"));
		super.imprimeDatos();
	}
};

public class Ejemplo3 
{
    public static void main(String[] args) 
	{
                Peon peon       = new Peon(1, 10, 5);
                Torre torre     = new Torre(2, 20, 5);
                Caballo caballo = new Caballo(3, 10, 10);
	
                Pieza pieza = torre;
	
                pieza.mueveEscaque(); // Llamada a mueveEscaque de Torre
                pieza.imprimeDatos(); // Llamada a imprimeDatos de Torre y Pieza

                Torre pTorre = (Torre)pieza; // Conversión

                pTorre.mueveEscaque();
                pTorre.imprimeDatos();
	
    }
}
