// Inclusión de paquetes

import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

// Clase ingeniero
class Ingeniero
{
	private int numero;
	private HashMap<String, Asignacion> asignaciones;
	
	public Ingeniero(int numero)
	{
		asignaciones = new HashMap<String, Asignacion>();
		this.numero = numero;
	}
	
	public boolean setAsignacion(Asignacion asignacion)
	{			
		// Evita repetidos
		if (asignaciones.get(asignacion.getId()) == null)
		{
			asignaciones.put(asignacion.getId(),asignacion);	
			System.out.println("es true" + asignacion.getId());
			return true;
		}
		System.out.println("REPETIDO");
		return false;
	}
	
	public String toString()
	{
		 return "Ingeniero " + numero;
	}
	
	public String getID()
	{
		return "ING" + numero;
	}
	
	public void  imprimeProyectos() 
	{
		System.out.println(this + " con los proyectos: ");
		
		Iterator i = asignaciones.entrySet().iterator();
		while(i.hasNext())
		{
			Map.Entry entrada = (Map.Entry)i.next();
			System.out.println(((Asignacion)entrada.getValue()).getProyecto());
		}
	}
	
}

// Clase asociación
public class Asignacion 
{
    private Ingeniero ingeniero;
    private Proyecto proyecto;
    private int presupuesto;
	private String id;
	
	public void addRelacion(Ingeniero ingeniero, Proyecto proyecto, int presupuesto)
	{
		// Genera clave
		id = ingeniero.getID() + proyecto.getID();
		this.ingeniero = ingeniero;
		this.proyecto  = proyecto;
		this.presupuesto = presupuesto;
		if (ingeniero.setAsignacion(this))
			proyecto.setAsignacion(this);
	}
	
	public String getId()
	{
		return id;
	}
	
	public Proyecto getProyecto()
	{
		return proyecto;
	} 

	public Ingeniero getIngeniero()
	{
		return ingeniero;
	}

}

// Clase proyecto
class Proyecto 
{
    private int numero;
	private HashMap<String, Asignacion> asignaciones;

	public Proyecto(int numero)
	{
		asignaciones = new HashMap<String, Asignacion>();
		this.numero = numero;
	}
	
	public void setAsignacion(Asignacion asignacion)
	{			
		asignaciones.put(asignacion.getId(),asignacion);	
	}
	
	
	public String toString()
	{
		 return "Proyecto " + numero;
	}
	
	public String getID()
	{
		return "PRY" + numero;
	}
	
	public void  imprimeIngenieros() {
		System.out.println(this + " con los ingenieros: ");
		
		Iterator i = asignaciones.entrySet().iterator();
		while(i.hasNext())
		{
			Map.Entry entrada = (Map.Entry)i.next();
			System.out.println(((Asignacion)entrada.getValue()).getIngeniero());
		}
	}
	
}

// Clase principal
class Inicio
{
	
	public static void main (String[] args) 
	{
		Ingeniero ingenieros[] = new Ingeniero[3];
		for (int i = 0; i < 3 ; i++)
			ingenieros[i] = new Ingeniero(i);
			
		Proyecto proyectos[] = new Proyecto[3];
		for (int i = 0; i < 3 ; i++)
			proyectos[i] = new Proyecto(i);
		
		Asignacion asignaciones[] = new Asignacion[3];
		for (int i = 0; i < 3 ; i++)
			asignaciones[i] = new Asignacion();
		
		asignaciones[0].addRelacion(ingenieros[0], proyectos[1],1000);
		asignaciones[1].addRelacion(ingenieros[1], proyectos[0],2000);
		asignaciones[2].addRelacion(ingenieros[1], proyectos[1],3000);
		
		ingenieros[1].imprimeProyectos();
		proyectos[1].imprimeIngenieros();
		
	}
}