package mercurial.interprete;

// Inclusión de paquetes
import mercurial.gestorcliente.*;
import mercurial.gestorarchivos.*;

// Clase de fachada
public class FachadaInterprete
{
	private IGestorCliente cliente;
	
	public FachadaInterprete()
	{
		cliente = new ClienteProgramador();
	}
	
	public void entradaTextoSistema()
	{
		// Inicia sesión
		interpretaComando1("init");
		// Borra fichero local
		interpretaComando2("delete a/b/p2.c");
		//interpretaComando2("delete a1/b3/c1/p2.c");
	}
	
	public void setComando(Comando comando)
	{
	}
	// Inicia sesión
	private void interpretaComando1(String comando)
	{
		// Llama al patrón interpréte
		Comando com1 = new Comando();
		com1.setId(1);
		com1.setComando("init");
		cliente.setComando(com1);
	}
	// Borra fichero local
	private void interpretaComando2(String comando)
	{
		// Llama al patrón interpréte
		Comando com2 = new Comando();
		com2.setId(2);
		com2.setComando("delete");
		com2.addParametros("raiz");
		com2.addParametros("a");
		com2.addParametros("b");
		com2.addParametros("p2.c");
		
		/*com2.addParametros("raiz");
		com2.addParametros("a1");
		com2.addParametros("b3");
		com2.addParametros("c1");
		com2.addParametros("p2.c");*/
		
		
		cliente.setComando(com2);
	}
	
}

// Clase principal
class Inicio
{
	public static void main (String[] args) throws Exception
	{
		FachadaInterprete interprete = new FachadaInterprete();
		// Comienzo de la interacción
		interprete.entradaTextoSistema();
	}
}