# Clase ingeniero
class Ingeniero:
    def __init__(self, numero):
        self.__numero = numero
        self.__asignaciones = {}
    
    def set_asignacion(self,asignacion):
        # Evita duplicados
        if not asignacion.get_id() in self.__asignaciones:
            self.__asignaciones[asignacion.get_id()] = asignacion
            print(f"es true {asignacion.get_id()}")
            return True
        
        return False
        
    def get_id(self):
        return "ING" + str(self.__numero)
    
    def __str__(self):
        return "Ingeniero " + str(self.__numero)
    
    def imprime_proyectos(self):
        print(self.__str__() + " con los proyectos: ")
        
        for i in self.__asignaciones:
            print(self.__asignaciones[i].get_proyecto())

# Clase asociación
class Asignacion:
    def add_relacion(self, ingeniero, proyecto, presupuesto):
        # Genera clave
        self.__id = ingeniero.get_id() + proyecto.get_id()
        self.__ingeniero = ingeniero
        self.__proyecto = proyecto
        self.__presupuesto = presupuesto
        
        if self.__ingeniero.set_asignacion(self):
            self.__proyecto.set_asignacion(self)
            return True
        return False    
            
    def get_id(self):
        return self.__id
    
    def get_proyecto(self):
        return self.__proyecto
   
    def get_ingeniero(self):
        return self.__ingeniero
        
# Clase proyecto
class Proyecto:
    def __init__(self, numero):
        self.__numero = numero
        self.__asignaciones = {}
    
    def set_asignacion(self, asignacion):
         self.__asignaciones[asignacion.get_id()] = asignacion
        
    def get_id(self):
        return "PRY" + str(self.__numero)
    
    def __str__(self):
        return "Proyecto " + str(self.__numero)
    
    def imprime_ingenieros(self):
        print(self.__str__() + " con los ingenieros: ")
        
        for i in self.__asignaciones:
            print(self.__asignaciones[i].get_ingeniero())

        

ingenieros = [Ingeniero(0), Ingeniero(1), Ingeniero(2)]
proyectos  = [Proyecto(0), Proyecto(1), Proyecto(2)]
asignaciones = [Asignacion(), Asignacion(), Asignacion()]

asignaciones[0].add_relacion(ingenieros[0], proyectos[1], 1000)
asignaciones[1].add_relacion(ingenieros[1], proyectos[0], 2000)
asignaciones[2].add_relacion(ingenieros[1], proyectos[1], 3000)
        
ingenieros[1].imprime_proyectos()
proyectos[1].imprime_ingenieros()        
    
            
        