import abc

# Patrón Observer. Clase Notificador
class Notificador:
    def __init__(self):
        self.__observers = []
    
    # Adjunta observador
    def adjunta(self, observer):
        self.__observers.append(observer)
        
    # Notifica a los observadores
    def notifica(self, mensaje_cifrado, clave, nonce, tag):
        for observer in self.__observers:
            observer.notifica(mensaje_cifrado, clave, nonce, tag)      
                        
# Interfaz Observer
class IObserver(metaclass = abc.ABCMeta):
    @abc.abstractmethod
    def notifica(self, mensaje_cifrado, clave, nonce, tag):
        pass
        
 
                   