from servidor.servidor import UsuarioAvanzado, Opcion

# Patrón Singleton y fachada de Menú    
class MenuServidor:
    _singleton = None
    def __new__(cls, *args, **kwargs):
        if not cls._singleton:
            cls._singleton = super(MenuServidor, cls
                ).__new__(cls, *args, **kwargs)
        return cls._singleton        
    # Mapa asociativo de selección
    def __init__(self):
        self.__menu_mapa = {
            "1" : self.__simetrico,
            "2" : self.__hibrido,
            "3" : self.__espera,
            "4" : self.__salir,
            }  
    # Introduce datos para usuario avanzado
    def __pedir_datos(self):
        nombre = input("Introduzca su nombre: ")
        login  = input("login: ")
        password = input("password: ")
        simbolico = input("Introduzca su nombre simbólico: ")
        while True:
            filtrar = input("¿Desea filtrar spam en mensaje cifrado (s/n)?").lower()
            if filtrar == "s" or filtrar == "n": 
                break
        return nombre, login, password, simbolico, filtrar
    
    # Opción cifrado simétrico
    def __simetrico(self):
      self.usuario.set_opcion(Opcion.SIMETRICO)
        
    # Opción cifrado híbrido
    def __hibrido(self):
      self.usuario.set_opcion(Opcion.HIBRIDO)
      
    # Pone en espera al servidor
    def __espera(self):
      self.usuario.espera_mensaje_cifrado()
        
    # Sale de la aplicación
    def __salir(self):
        raise SystemExit()
      
    # Imprime menú
    def __imprime_menu(self):
        print(
            """
            Menu Servidor 
            ---------------------

            1. Cifrado simétrico
            2. Cifrado híbrido
            3. Poner en espera 
            4. Salir
            """
        )  

    # Imprime menú y selecciona opción
    def inicio(self):            
        try:
            opc = ""
            print("Bienvenido al servidor de cifrado remoto")
            print("----------------------------------------------------\n")
            nombre, login, password, simbolico, filtrar = self.__pedir_datos()
            self.usuario =  UsuarioAvanzado(nombre, login, password, simbolico, filtrar)
            while True:
               self.__imprime_menu()
               opc = input("Introduzca un número de opción: ")
               try: 
                    func = self.__menu_mapa[opc]
               except KeyError:
                    print("{} no es una opción válida".format(opc))
               else:
                    func()
        finally:
            print(f"Gracias por enviar su mensaje cifrado {simbolico}")
        
            

